function love.load()
	lgr = love.graphics
	lmo = love.mouse
	require("maths")
	garm = require("garm")
	
	lgr.setBackgroundColor(255, 255, 255)
	math.randomseed(os.time())
	
	distance = 30
	radius = math.sqrt(2*distance^2)/1.8

	local h = 20
	local r, g, b = garm.HSV(h, 255, 255, 255)
	cc = {r = r, g = g, b = b, h = h}
	createCircles()
end

function love.draw()
	lgr.setColor(cc.r, cc.g, cc.b)
	for _, c in pairs(circles) do
		lgr.circle("fill", c.x, c.y, math.max(0, c.r), 50)
	end
end

function love.update(dt)
	for _, c in pairs(circles) do
		c.r = (c.r - radius)*(0.05^dt) + radius
	end
end

function love.keypressed()
	lgr.setBackgroundColor(cc.r, cc.g, cc.b)
	local nh = (cc.h + 60 + math.random(120))%256
	local r, g, b = garm.HSV(nh, 255, 255, 255)
	cc = {r = r, g = g, b = b, h = nh}
	createCircles()
end

function createCircles()
	circles = {}
	for x = 0, lgr.getWidth() + distance, distance do
		for y = 0, lgr.getHeight() + distance, distance do
			local r = math.random(0, -math.sqrt(50)*50)
			table.insert(circles, {x = x, y = y, r = r})
		end
	end
end

--[[--
function love.draw() end
function love.errhand(msg) end
function love.focus(f) end
function love.gamepadaxis(joystick, axis, value) end
function love.gamepadpressed(joystick, button) end
function love.gamepadreleased(joystick, button) end
function love.joystickadded(joystick) end
function love.joystickaxis(joystick, axis, value) end
function love.joystickhat(joystick, hat, direction) end
function love.joystickpressed(joystick, button) end
function love.joystickreleased(joystick, button) end
function love.joystickremoved(joystick) end
function love.keypressed(key, isrepeat) end
function love.keyreleased(key) end
function love.load(arg) end
function love.mousefocus(f) end
function love.mousemoved(x, y, dx, dy) end
function love.mousepressed(x, y, button) end
function love.mousereleased(x, y, button) end
function love.quit() end
function love.resize(w, h) end
function love.run() end
function love.textinput(text) end
function love.threaderror(thread, errorstr) end
function love.update(dt) end
function love.visible(v) end
--]]--